from stub import zapytanie

def koduj(a, b, n):
    return a * n + b

def rozwiaz(n):
    przekatne_od_0 = set()
    for i in range(1, n - 1):
        if zapytanie(0, i):
            przekatne_od_0.add(i)
    
    # Jeśli istnieje przekątna dzieląca wielokąt dokładnie na pół,
    # to musi to być odpowiedź, ponieważ każda inna przekątna będzie
    # miała większą odległość w lewo lub w prawo (ponieważ pozostałe
    # przekątne znajdą się albo po lewej, albo po prawej stronie
    # wielokąta podzielonego tą przekątną).
    if n // 2 in przekatne_od_0:
        return koduj(0, n // 2, n)
    
    # W przeciwnym razie próbujemy znaleźć najbliższe punkty po przeciwnej
    # stronie od 0, które mają przekątne idące zarówno w lewo, jak i w prawo
    # od tego wielokąta.
    lewy, prawy = 1, n - 1
    for i in range(2, n // 2):
        if i in przekatne_od_0:
            lewy = i
    for i in range(n - 2, (n + 1) // 2 - 1, -1):
        if i in przekatne_od_0:
            prawy = i
    
    # Ta przekątna musi istnieć, ponieważ nie mamy przekątnej łączącej 0
    # z punktem po przeciwnej stronie od 0, a to jest pełna triangulacja.
    # Zatem to jest nasza odpowiedź.
    return koduj(lewy, prawy, n)
